#ifndef Uart_H
#define Uart_H
#endif


void  UART1Init (U1BRG)
 {
 TRISBbits.TRISB0 = 1;	 //Ready To Send - (RTS) is an output
 TRISBbits.TRISB2 = 0;
U1BRG = 51;               // 9600 bd 
 U1MODEbits.UARTEN = 0;        // Bit15 TX, RX DISABLED, ENABLE at end of func
    U1MODEbits.USIDL = 0;         // Bit13 Continue in Idle
    U1MODEbits.IREN = 0;          // Bit12 No IR translation
    U1MODEbits.RTSMD = 0;         // Bit11 Simplex Mode
    U1MODEbits.UEN0 = 0;          // Bits8,9 TX,RX enabled, CTS,RTS not
    U1MODEbits.UEN1 = 0; 
    U1MODEbits.WAKE = 0;          // Bit7 No Wake up (since we don't sleep here)
    U1MODEbits.LPBACK = 0;        // Bit6 No Loop Back
    U1MODEbits.ABAUD = 0;         // Bit5 No Autobaud (would require sending '55')
    U1MODEbits.RXINV = 0;         // Bit4 IdleState = 1
    U1MODEbits.BRGH = 0;          // Bit3 16 clocks per bit period
    U1MODEbits.PDSEL1 = 0;        // Bits1,2 8bit, No Parity
    U1MODEbits.PDSEL0 = 0; 
    U1MODEbits.STSEL = 0;         // Bit0 One Stop Bit




    U1STAbits.UTXISEL1 = 0;       //Bit15 Int when Char is transferred (1/2 config!)
    U1STAbits.UTXINV = 0;         //Bit14 N/A, IRDA config
    U1STAbits.UTXISEL0 = 0;       //Bit13 Other half of Bit15
    U1STAbits.UTXBRK = 0;         //Bit11 Disabled
    U1STAbits.UTXEN = 0;          //Bit10 TX pins controlled by periph
    U1STAbits.UTXBF = 0;          //Bit9 *Read Only Bit*
    U1STAbits.TRMT = 0;           //Bit8 *Read Only bit*
    U1STAbits.URXISEL0 = 0;       //Bits6,7 Int. on character recieved
    U1STAbits.URXISEL1 = 0; 
    U1STAbits.ADDEN = 0;          //Bit5 Address Detect Disabled
    U1STAbits.RIDLE = 0;          //Bit4 *Read Only Bit*
    U1STAbits.PERR = 0;           //Bit3 *Read Only Bit*
    U1STAbits.FERR = 0;           //Bit2 *Read Only Bit*
    U1STAbits.OERR = 0;           //Bit1 *Read Only Bit*
    U1STAbits.URXDA = 0;          //Bit0 *Read Only Bit*
   

    U1MODEbits.UARTEN = 1;        // And turn the peripheral on
    U1STAbits.UTXEN = 1;
    IFS0bits.U1RXIF = 0;     // reset RX interrupt flag 
    //IEC0bits.U1RXIE = 1;	// this is cousing the programe to reset	
}

	
void  UART1_Write( char ch)
{

while( U1STAbits.UTXBF==1);
U1TXREG=ch;
}
// Uart trasmit function 




unsigned char UART1_Read() 
{
char rec_data;
while (IFS0bits.U1RXIF == 0); 
rec_data= U1RXREG;
 IFS0bits.U1RXIF = 0; // reset interrupt 
return rec_data;
 //return 0;
}