

#include <p24FJ64GA002.h>
#define FCY 8000000LL
#include <libpic30.h> 
#include <stdio.h>
#include <math.h>

#include "protocol.h"
#include "Uart.h"
#define LED1			LATBbits.LATB5		//_LATB6
#define LED2			LATBbits.LATB6		//_LATB9

_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF & ICS_PGx1) 
_CONFIG2( FNOSC_FRCPLL & OSCIOFNC_OFF );

	char wake_up()
{
     char i;
     for( i=0; i<9; i++)
{
          UART1_Write(CMD_BREAK);
          if(UART1_Read() == STS_SUCCESS) 
          return 0;
          	__delay_us(5);
     }
     return 1;
}

char v_sleep()
{
     UART1_Write(CMD_SLEEP);
     UART1_Write(ARG_ZERO + 5);
     if(UART1_Read() == STS_SUCCESS) return 0;
     else return 1;
}
//******************************************************************************

//******************************************************************************
char v_setup()
{
     UART1_Write(CMD_ID);
     if(UART1_Read() != STS_ID) 
     return 1;      // not successsful 
     __delay_ms(100);
     UART1_Write(ARG_ACK);
     if(UART1_Read() != ARG_ZERO)
     return 1;
	__delay_ms(100);
     UART1_Write(CMD_LANGUAGE);
     UART1_Write(ARG_ZERO);              //English language
   
     if(UART1_Read() != STS_SUCCESS) 
     return 1;
       	__delay_ms(5);
     UART1_Write(CMD_TIMEOUT);
     UART1_Write(ARG_ZERO + 5);          
     if(UART1_Read() != STS_SUCCESS)
     return 1;
     return 0;
}
char v_recognize(char cmd, char group) {
     char rslt;
     UART1_Write(cmd);
     UART1_Write(ARG_ZERO + group);
     //while(!UART1_Data_Ready());
     rslt = UART1_Read();
     if((rslt == STS_RESULT)|| (rslt == STS_SIMILAR))
{
       	__delay_ms(5);
        UART1_Write(ARG_ACK);
        //while(!UART1_Data_Ready());
        return UART1_Read() - ARG_ZERO;
     }
     return rslt;
}    





int main()
 {
     char recog_result;
   
 T1CON = 0b00000000;         // Timer1 off, prescaler 1:1, Fosc/4 source
     OSCTUN=0x0000;             
     OSCCON = 0x0000;         // 8 MHz, internal osc
     CLKDIV =0x0000;         // DO NOT DIVIDE 
     CMCON = 0;              // turn off comparator
     RCONbits.SWDTEN =0;    //watch dog 

    //Define PortA
    TRISA = 0xFFFF;
    
   
    RPINR18bits.U1RXR = 0;  //  UART1 RX to pin RP0
    RPINR18bits.U1CTSR = 1; // ASSIGN U1CTSR TO PIN RP1
    RPOR1bits.RP2R = 3;     // ASSIGN U1TX TO PIN PR2
    RPOR1bits.RP3R = 4;  //  ASSIGN U1RTS TO PIN RP3

    UART1Init(U1BRG );     //initiall
     __delay_us(100);
    LED1=1;
  __delay_us(100);//100
     if(wake_up() == 0) {
      LED1=0;
      __delay_ms(100);
        LED1=1;
       __delay_ms(100);
       if(v_setup() == 0) {
        LED2=1;
        __delay_ms(100);
         LED2=0;
        	__delay_ms(100)
        }
     }
    
     while(1){
     if(wake_up() == 0) {
         LED1=0;
     }
     do{
     __delay_ms(5);
     recog_result = v_recognize(CMD_RECOG_SD,0);
     if(recog_result == 0)       // Tv is recorgnise 
{       
      // flash led     
        
      	__delay_ms(5);
         
         do{
          	__delay_ms(5);
         recog_result = v_recognize(CMD_RECOG_SD,1);
         if(recog_result == 0)     //channel down 
      {                                   
           // flash led 
         	__delay_ms(5);
         
         }
         if(recog_result == 1)// channel down 
           {       
           //flash led 
         	__delay_ms(5);
         
            }
       if(recog_result ==2)     
       {             
         //flas LED=;
       	__delay_ms(5);
   
       }  
    } while (recog_result != STS_TIMEOUT );
     }
     
     } while(recog_result != STS_TIMEOUT );
     do{
        	__delay_ms(100);
     }while(v_sleep() != 0);
    

    // return 0;
     }
}

